function [deltas,deltas2]=hsampsondist(m,H)


deltas=[];

N=size(m,1);

deltas=zeros(N,4);
deltas2=zeros(N,1);

zerov=zeros(3,1);
for idx=1:N
  epsilon=costsam2(m(idx,:),H);

  if epsilon==zerov
    continue;
  end
  
  JJt=zeros(3,3);
  J=zeros(3,4);
  Ev=zeros(1,4);
  for i=1:4
    Ei=Ev;
    Ei(i)=1;
    dCdXi=costsam2(m(idx,:)+Ei,H)-epsilon;
    JJt=JJt+dCdXi*dCdXi';
    J(:,i)=dCdXi;
  end
  lambda=-(JJt\epsilon);
  deltas(idx,:)=(J'*lambda)';  
end

deltas2=sum(deltas.^2,2);

function C=costsam2(X,H)

xL=[X(1);X(2);1];
xR=[X(3);X(4);1];
C=cross(xR,H*xL);

 
